/*-----------------------------------
     
-------------------------------------
*/
typedef struct {
	unsigned char kanji1;
	unsigned char kanji2;
	unsigned char kanji3;
	unsigned char kanji4;
	unsigned char kanji5;
} KANJI;
/*=============================================================================
//   Ѵ
//=============================================================================
*/
char keta[1024];
char *keta_henkan(long long int suu){
	double tb;
	double gb;
	double mb;
	double kb;
	bzero(keta,1024);

	kb=suu/1024;
	mb=kb/1024;
	gb=mb/1024;
	tb=gb/1024;

	if (tb>=10){
		tb=ceil(tb);
		sprintf(keta,"%.0fT",tb);
		return keta;
	}
	if (tb>=1){
		tb=ceil(tb*10)/10;
		sprintf(keta,"%.1fT",tb);
		return keta;
	}

	if (gb>=10){
		gb=ceil(gb);
		sprintf(keta,"%.0fG",gb);
		return keta;
	}
	if (gb>=1){
		gb=ceil(gb*10)/10;
		sprintf(keta,"%.1fG",gb);
		return keta;
	}

	if (mb>=10){
		mb=ceil(mb);
		sprintf(keta,"%.0fM",mb);
		return keta;
	}
	if (mb>=1){
		mb=ceil(mb*10)/10;
		sprintf(keta,"%.1fM",mb);
		return keta;
	}

	if (kb>=10){
		kb=ceil(kb);
		sprintf(keta,"%.0fK",kb);
		return keta;
	}
	if (kb>=1){
		kb=ceil(kb*10)/10;
		sprintf(keta,"%.1fK",kb);
		return keta;
	}
	sprintf(keta,"%d",suu);
	return keta;
}
/*=============================================================================
//    ǻꤷꥢ塢ǻꤷꥢ
//
//    IN   char *a_moto ʸ
//         char *a_saki ʸ
//    OUT  ʸؤΥݥ󥿡
//=============================================================================
*/
char *str_dainyu(char *a_moto, char *a_saki) {

	/*ѿ*/
	int nagasa;
	char *kekka;

	/*Υꥢ*/
	free(a_moto);

	/*ꥢĹ*/
	nagasa=strlen(a_saki);

	/**/
	if (NULL == (kekka=malloc(nagasa+1))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}

	/*ꥢإԡ*/
	bzero(kekka,nagasa+1);
	strcpy(kekka, a_saki);

	return kekka;
}
/*=============================================================================
//  ǻꤵ줿ʸǼʬΥݤơȤ򥳥ԡ롣
//
//    IN   char *a_moto ʸ
//    OUT  ݤΥݥ󥿡
//=============================================================================
*/
char *char_malloc(char *a_moto) {

	/*ѿ*/
	int nagasa;
	char *a_saki;

	/*Ĺ¬äơNULLɤʬ䤹*/
	nagasa=strlen(a_moto);
	nagasa++;

	/**/
	if (NULL == (a_saki=malloc(nagasa))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}
	bzero(a_saki,nagasa);

	/*  ԡ */
	strcpy(a_saki, a_moto);
	return a_saki;
}
/*=============================================================================
//  ǻꤵ줿ʸǼʬΥݤơȤ򥳥ԡ롣
//  ޤκݤϢ뤹
//    IN   char *a_moto ʸ
//    OUT  ݤΥݥ󥿡
//=============================================================================
*/
char *char_malloc2(char *a_moto1, char *a_moto2) {

	/*ѿ*/
	int nagasa1;
	int nagasa2;
	int nagasa;
	char *a_saki;

	/*Ĺ¬äơNULLɤʬ䤹*/
	nagasa1=strlen(a_moto1);
	nagasa2=strlen(a_moto2);
	nagasa=nagasa1+nagasa2+1;

	/**/
	if (NULL == (a_saki=malloc(nagasa))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}
	bzero(a_saki,nagasa);

	/*  ԡ */
	strcpy(a_saki, a_moto1);
	strcat(a_saki, a_moto2);
	return a_saki;
}
/*=============================================================================
//  ѤΣХܤȾѤȽ
//
//   IN: int kubun
//           0: եJIS
//           1: ţգ
//        unsigigned char code 
//           ХܤΥ饯
//
//  OUT:  0: Ⱦ
//        1: ѣʸ
//=============================================================================
*/
int hzhanbetu (int kubun, unsigned char code) {

	int hanbetu;
	hanbetu=0;

	/* եȣʣɣ */
	if (kubun==0){
		if ((code>=128 && code<=159) || code>=224){
			hanbetu=1;
		}
	}

	/* ţգ */
	if (kubun==1){
		if ((code>=161 && code<=254) || code==142){
			hanbetu=1;
		}
	}

	return hanbetu;
}

/*=============================================================================
//  ţգâӣʣɣ
//
//    IN   char *a_moto ѴʸΥݥ󥿡
//    OUT  ݤΥݥ󥿡
//         ȤΥݥ󥿡ϲޤ
//=============================================================================
*/
char *euc2sjis(char *a_moto) {

	/*ѿ*/
	int nagasa;
	char *kekka;
	int cnt;
	int cnt2;
	unsigned char moji;
	unsigned char moji1;
	unsigned char moji2;
	int zenkaku;
	KANJI kj;

	/*ꥢĹ*/
	nagasa=strlen(a_moto);

	/**/
	if (NULL == (kekka=malloc(nagasa+2))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}
	bzero(kekka,nagasa+2);

	zenkaku=0;
	cnt2=0;
	for (cnt=0;cnt<nagasa;cnt++){

		moji = *(a_moto+cnt);

		//ѤΣХܤ
		if (zenkaku==1){
			moji2=moji;
			zenkaku=0;

			//Ⱦѥʤʤ飱Хܤ
			if (moji1==142) {
				*(kekka+cnt2) = moji2;
				cnt2++;
				continue;
			}

			//ʣɣӥɤˤ
			moji1 = moji1 - 0x80;
			moji2 = moji2 - 0x80;

			//եȣʣɣӤˤ
			kj.kanji4 = moji1;
			kj.kanji5 = moji2;
			jisconv(&kj);
			moji1 = kj.kanji4;
			moji2 = kj.kanji5;

			*(kekka+cnt2)   = moji1;
			*(kekka+cnt2+1) = moji2;
			cnt2=cnt2+2;
			continue;
		}

		//ѤΣХܤ
		if (hzhanbetu(1,moji)){
			zenkaku=1;
			moji1=moji;
		} else {
			zenkaku=0;
			*(kekka+cnt2)=moji;
			cnt2++;
		}
	}

	/*Υꥢ*/
	free(a_moto);

	return kekka;
}

/*=============================================================================
//     JIS  SHIFT-JIS
//
//    IN   KANJI kanjicode
//    OUT  1:Ѵ  0:Ѵ
//=============================================================================

*/
int jisconv(KANJI *kanjicode) {

	int much;
	unsigned char moji1;
	unsigned char moji2;

	much=0;
	moji1 = (unsigned char) kanjicode->kanji4;
	moji2 = (unsigned char) kanjicode->kanji5;

	/* ̥ХȤ */
	if ((moji1&1)==0){
		/*---- ----*/
		moji2+=0x7e;
		moji1--;
	} else {
		/*---- ----*/
		moji2+=0x1f;
		if (moji2>=0x7f) {
			moji2++;
		}
	}

	moji1-=0x1f;
	moji1>>=1;
	moji1+=0x80;

	if (moji1>=0xa0) {
		moji1+=0x40;
	}

	much=1;
	kanjicode->kanji4=moji1;
	kanjicode->kanji5=moji2;

	return much;
}
/*=============================================================================
//  ʸκǸ/ä顢̥֤
//    IN   char *a_moto ʸ
//    OUT  ʤ
//=============================================================================
*/
void slashcut(char *a_moto) {

	int len;
	char *p;
	char moji;

	len=strlen(a_moto);
	if (len<=1){
		return;
	}

	p=a_moto+len;
	while(p>=a_moto){
		moji=*p;
		if (moji!=0x00){
			if (moji=='/'){
				*p=0x00;
			}
			break;
		}
		p--;
	}
}
